/// <reference types="youtube" />
declare global {
    interface Window {
        onYouTubeIframeAPIReady: () => void;
    }
}
export declare class YoutubeVideoElement extends HTMLElement {
    static scriptLoadPromise: Promise<void>;
    static triggerYoutubeIframeAPIReady: () => void;
    ytPlayer: YT.Player;
    paused: boolean;
    ytPlayerContainer: HTMLElement;
    private resolveBuildPlayerPromise;
    private ytPlayerPromise;
    private scriptPath;
    private mediaError;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    get height(): number;
    get width(): number;
    get src(): string;
    get autoplay(): boolean;
    get playsinline(): boolean;
    get id(): string;
    get controls(): boolean;
    get ytPlayerVars(): YT.PlayerVars;
    get srcQueryParams(): YT.PlayerVars;
    load(): Promise<YT.Player>;
    get videoId(): string;
    play(): void;
    pause(): void;
    createYTPlayerElement(): HTMLDivElement;
    private onPlay;
    private onPause;
    private onEnd;
    set error(error: Error);
    get error(): Error;
    private _onYTApiStateChange;
    private loadYTScript;
    private unloadYTScript;
    private buildPlayer;
}
